/******************************************************************************
* Copyright (C) 2008 - Ikaro Games   www.ikarogames.com                       *
*                                                                             *
* This program is free software; you can redistribute it and/or               *
* modify it under the terms of the GNU General Public License                 *
* as published by the Free Software Foundation; either version 2              *
* of the License, or (at your option) any later version.                      *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* along with this program; if not, write to the Free Software                 *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
*                                                                             *
*                                                                             *
*       generated by dia/DAOcodegen.py                                        *
*       Version: 1.15                                                         *
******************************************************************************/

#include <stdlib.h>

#include "CPfMatchesDAOSQLiteEntity.h"
#include "../../../../utils/CLog.h"

CPfMatchesDAOSQLiteEntity::CPfMatchesDAOSQLiteEntity(sqlite3 *database)
{
    m_database = database;
}

CPfMatchesDAOSQLiteEntity::~CPfMatchesDAOSQLiteEntity()
{
}

void CPfMatchesDAOSQLiteEntity::setSQLite(sqlite3 *database)
{
    m_database = database;
}

bool CPfMatchesDAOSQLiteEntity::deleteReg(CPfMatches *reg)
{
    std::string sql("DELETE FROM PF_MATCHES WHERE X_MATCH=");
    sql = sql+"'"+reg->getXMatch_str()+"'";
    return exec(sql);
}

bool CPfMatchesDAOSQLiteEntity::insertReg(CPfMatches *reg)
{
    std::string sql("INSERT INTO PF_MATCHES (D_MATCH,L_PLAYED,X_FK_TEAM_HOME,X_FK_TEAM_AWAY) VALUES (");
    sql = sql+" '"+reg->getDMatch_str()+"'";
    sql = sql+",'"+reg->getLPlayed_str()+"'";
    sql = sql+",'"+reg->getXFkTeamHome_str()+"'";
    sql = sql+",'"+reg->getXFkTeamAway_str()+"'";
    sql = sql+")";
    return exec(sql);
}

bool CPfMatchesDAOSQLiteEntity::updateReg(CPfMatches *reg)
{
    std::string sql("UPDATE PF_MATCHES SET ");
    sql = sql+" D_MATCH='"+reg->getDMatch_str()+"'";
    sql = sql+",L_PLAYED='"+reg->getLPlayed_str()+"'";
    sql = sql+",X_FK_TEAM_HOME='"+reg->getXFkTeamHome_str()+"'";
    sql = sql+",X_MATCH='"+reg->getXMatch_str()+"'";
    sql = sql+",X_FK_TEAM_AWAY='"+reg->getXFkTeamAway_str()+"'";
    sql = sql+" WHERE X_MATCH='"+reg->getXMatch_str()+"'";
    return exec(sql);
}

void CPfMatchesDAOSQLiteEntity::freeVector(std::vector<CPfMatches*>* vector )
{
    std::vector<CPfMatches*>::iterator it;
    for( it=vector->begin(); it!=vector->end(); it++ ){
        delete (*it);
        (*it) = NULL;
    }
    delete vector;
}

CPfMatches* CPfMatchesDAOSQLiteEntity::loadRegister(const std::string &sql)
{
    if( m_database==NULL ){
        CLog::getInstance()->exception("[CPfMatchesDAOSQLiteEntity::loadRegister] No database connection.");
    }

    char *msgError = NULL;
    CPfMatches *destiny = new CPfMatches();
    if( sqlite3_exec(m_database, sql.c_str(), callbackRegister, destiny, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
    }
    return destiny;
}

std::vector<CPfMatches*> * CPfMatchesDAOSQLiteEntity::loadVector(const std::string &sql)
{
    if( m_database==NULL ){
        CLog::getInstance()->exception("[CPfMatchesDAOSQLiteEntity::loadVector] No database connection.");
    }

    char *msgError = NULL;
    std::vector<CPfMatches*> *container = new std::vector<CPfMatches*>;
    if( sqlite3_exec(m_database, sql.c_str(), callbackVector, container, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
    }
    return container;
}

bool CPfMatchesDAOSQLiteEntity::exec(const std::string &sql)
{
    if( m_database==NULL ){
        CLog::getInstance()->exception("[CPfMatchesDAOSQLiteEntity::exec] No database connection.");
    }

    char *msgError = NULL;
    bool correct = true;
    if( sqlite3_exec(m_database, sql.c_str(), NULL, NULL, &msgError)!=SQLITE_OK ){
        CLog::getInstance()->error("Error in SQL: \"%s\" --> \"%s\"", sql.c_str(), msgError);
        sqlite3_free(msgError);
        correct = false;
    }
    return correct;
}

int CPfMatchesDAOSQLiteEntity::callbackRegister(void *object, int nColumns, char **vColumn, char **sColumn)
{
    int error = 1;
    if( object!=NULL ){
        CPfMatches *destiny = (CPfMatches*)object;
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "D_MATCH")==0 ){
                destiny->setDMatch_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "L_PLAYED")==0 ){
                destiny->setLPlayed_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_TEAM_HOME")==0 ){
                destiny->setXFkTeamHome_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_MATCH")==0 ){
                destiny->setXMatch_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_TEAM_AWAY")==0 ){
                destiny->setXFkTeamAway_str(vColumn[i]);
            }
        }
        error = 0; // All OK
    }
    return error;
}

int CPfMatchesDAOSQLiteEntity::callbackVector(void *object, int nColumns, char **vColumn, char **sColumn)
{
    if( object!=NULL ){
        std::vector<CPfMatches*> *container = (std::vector<CPfMatches*> *)object;
        CPfMatches *destiny = new CPfMatches();
        for( int i=0; i<nColumns; i++ ){
            if( strcmp(sColumn[i], "D_MATCH")==0 ){
                destiny->setDMatch_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "L_PLAYED")==0 ){
                destiny->setLPlayed_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_TEAM_HOME")==0 ){
                destiny->setXFkTeamHome_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_MATCH")==0 ){
                destiny->setXMatch_str(vColumn[i]);
            }else if( strcmp(sColumn[i], "X_FK_TEAM_AWAY")==0 ){
                destiny->setXFkTeamAway_str(vColumn[i]);
            }
        }
        container->push_back(destiny);
    }
    return 0; // All OK
}

